#!/usr/bin/python3
"""This module represents the CLI of the program."""
import sys

import click
import yaml

from trafficAI import automata, graphic


@click.group()
@click.argument('system', type=click.Path(exists=True))
@click.pass_context
def main(ctx, system: str) -> None:
    """
    TrafficAI command line interface.

    \b
    ARGUMENTS:
        SYSTEM:     path to the file with the definition of the traffic system

    \b
    ENVIRONMENT VARUABLES:
        CELL_LENGTH: determine the size of the cell in px

    """
    with open(system, 'r') as f:
        system = yaml.load(f)

    ctx.obj = {
        'system': system,
    }


@main.command()
@click.option('--nn-file', type=click.Path(exists=True),
             help='NN file generated by the `develop` command')
@click.pass_context
def run(ctx, nn_file: str) -> None:
    """
    Load and execute the system.
    """
    core = automata.CoreController(**ctx.obj['system'])

    presenter = graphic.Presenter(**ctx.obj['system'])
    presenter.main_loop(core)


@main.command()
@click.pass_context
def check(ctx) -> None:
    """
    Validates the system and show it using the GUI.
    """
    graphic.Presenter(**ctx.obj['system'])
    input('Press any key to exit the view.\n>> ')
